﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package {
	import org.osmf.traits.MediaTraitType;
	import org.osmf.traits.LoadTrait;
	import org.osmf.layout.ScaleMode;
	import org.osmf.layout.LayoutMetadata;
	import org.osmf.elements.ImageElement;
	import org.osmf.utils.OSMFSettings;
	import org.osmf.events.LoadEvent;
	import org.osmf.events.TimeEvent;
	import org.osmf.media.MediaPlayerSprite;
	import org.osmf.containers.MediaContainer;
	import org.osmf.media.MediaPlayer;
	import org.osmf.media.URLResource;
	import org.osmf.elements.VideoElement;
	import org.osmf.net.NetLoader;

	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0x000000")] 

	public class Main extends Sprite
	{		
		private static const LOGO_PNG : String = "http://www.actionscript-facile.com/wp-content/uploads/2011/10/logo-as3.jpg";// l'url de l'image de la vidéo
		
		private const VIDEO_URL:String = "http://chilp.it/2b032b";// l'url vers votre vidéo
		
		private var mediaContainer:MediaContainer;
		private var oMediaPlayerSprite:MediaPlayerSprite;
		
 
		private var oTrackVideo:Sprite;// barre d'indication de la vidéo
		private var oPisteVideo:Sprite;// barre avance rapide de la vidéo
		private var oProgressPlayVideo:Sprite;// barre de progression de la lecture de la vidéo
		
			
		private var nTotalBytesKo : uint;				// la taille de la vidéo en Ko
		private var oInfosDuration : UITextField;		// durée écoulée en lecture
		private var oInfosEvents : UITextField;			// texte de chargement en cours...
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, this, "Start osmf");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			MonsterDebugger.trace(this, "VIDEO_URL : "+VIDEO_URL);
			
			var oLogo:ImageElement = addPlayerPicture();
			
			addPlayerVideo(oLogo);
			addPlayerCommand();
		}
		
		
		/**
		 * Ajoute une image type "watermark" au dessus de la vidéo
		 * 
		 */
		private function addPlayerPicture() : ImageElement
		{
			// création de l'image au dessus de la vidéo
			var logo:ImageElement = new ImageElement( new URLResource(LOGO_PNG) );
			logo.smoothing = true;
			
			// Création d'un layout pour l'image			
			var logoLayout:LayoutMetadata = new LayoutMetadata();
			logo.addMetadata(LayoutMetadata.LAYOUT_NAMESPACE, logoLayout);
			
			// réduit la taille de l'image
			logoLayout.height = 70;
			logoLayout.width = 70;

			// positionne l'image en bas à droite du container de la vidéo
			logoLayout.bottom = 0;
			logoLayout.right = 0;
			
			// positionne l'image en haut à gauche du container de la vidéo			
			/*logoLayout.left = 10;	
			logoLayout.top = 10;*/	
			
			// Conserve les proportions de l'image
			logoLayout.scaleMode = ScaleMode.LETTERBOX;
			
			var oLoadTrait:LoadTrait = logo.getTrait( MediaTraitType.LOAD ) as LoadTrait;
			oLoadTrait.load();// lance le chargement de l'image

			return logo;
		}


		/**
		 * Ajoute le lecteur vidéo
		 * 
		 * @param oLogo : le logo à afficher par dessus la vidéo.
		 * 
		 */
		private function addPlayerVideo(oLogo:ImageElement) : void
		{
			OSMFSettings.enableStageVideo = true;// désactive / active la fonctionnalité StageVideo (améliore les performances si active)

			var media:VideoElement = new VideoElement( new URLResource( VIDEO_URL ), new NetLoader() );// création de l'élément vidéo
			
			// le player
			var mediaPlayer:MediaPlayer = new MediaPlayer( media );
			mediaPlayer.addEventListener(TimeEvent.CURRENT_TIME_CHANGE, onCurrentTimeChangeHandler );
			mediaPlayer.addEventListener(LoadEvent.BYTES_TOTAL_CHANGE, onBytesTotalChange);
			mediaPlayer.addEventListener(LoadEvent.BYTES_LOADED_CHANGE, onBytesLoadedChange);
			
			// container de la vidéo
			mediaContainer = new MediaContainer();
			mediaContainer.addMediaElement( media );
			mediaContainer.addMediaElement( oLogo );
 			mediaContainer.width = stage.stageWidth;// la taille du container de la vidéo
 			
			// pour afficher le player
			oMediaPlayerSprite = new MediaPlayerSprite( mediaPlayer, mediaContainer );
			oMediaPlayerSprite.addEventListener( MouseEvent.CLICK, onPlayPauseClick, false, 0, true );
			addChild( oMediaPlayerSprite );
		}


		/**
		 * Ajoute les boutons du Player
		 * 
		 */
		private function addPlayerCommand() : void
		{
			addMediaPlayerTracks( stage.stageWidth, 10 );// ajoute les barres avance rapide du player
			
			// ajout d'un texte informatif
			oInfosEvents = this.addText("Chargement en cours...");
			oInfosEvents.x = 226;
			oInfosEvents.y = 375;
			this.addChild(oInfosEvents);
			
			
			// durée de la vidéo
			oInfosDuration = this.addText("00:00");
			oInfosDuration.x = 432;
			oInfosDuration.y = oInfosEvents.y;
			this.addChild(oInfosDuration);
			
			
			// Création des boutons
			var oBtnPlayPause:DefaultButton = new DefaultButton();
			oBtnPlayPause.getObject().label = "Play / Pause";
			oBtnPlayPause.getObject().x = 10;
			oBtnPlayPause.getObject().y = oInfosEvents.y;
			oBtnPlayPause.getObject().addEventListener ( MouseEvent.CLICK, onPlayPauseClick );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnPlayPause);
			
			
			var oBtnMute:DefaultButton = new DefaultButton();
			oBtnMute.getObject().label = "Audio on/off";
			oBtnMute.getObject().x = oBtnPlayPause.getObject().x + oBtnPlayPause.width + 10;
			oBtnMute.getObject().y = oInfosEvents.y;
			oBtnMute.getObject().addEventListener ( MouseEvent.CLICK, onToggleMuteClick );// ajout d'un écouteur de l'évènement MouseEvent.CLICK
			this.addChild(oBtnMute);
		}

 
 		/**
 		 * La barre pour naviguer dans la vidéo.
 		 * Création de la barre de progression.
 		 * 
 		 */
		private function addMediaPlayerTracks( nWidth:Number, nHeight:Number ):void
		{
			// barre d'indication de la vidéo
			oTrackVideo = new Sprite();
			oTrackVideo.mouseEnabled = false;// désactive le clique de l'utilisateur
			oTrackVideo.graphics.beginFill( 0x666666, 0.6 );// la couleur - transparence alpha
			oTrackVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oTrackVideo.graphics.endFill();
			oTrackVideo.visible = false;// masquée par défaut
			addChild( oTrackVideo );
			
			
			// La barre pour l'avance rapide dans la vidéo.
			oPisteVideo = new Sprite();
			oPisteVideo.addEventListener(MouseEvent.CLICK, onTrackClickPlay, false, 0, true );
			oPisteVideo.graphics.beginFill( 0x696969, 0.8 );
			oPisteVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oPisteVideo.graphics.endFill();
			oPisteVideo.visible = false;// masquée par défaut
			addChild( oPisteVideo );
			
			
			// Création de la barre de progression de lecture de la vidéo.
			oProgressPlayVideo = new Sprite();
			oProgressPlayVideo.mouseEnabled = false;// désactive le clique de l'utilisateur
			oProgressPlayVideo.graphics.beginFill( 0xffffff, 0.6 );
			oProgressPlayVideo.graphics.drawRect( 0, 0, nWidth, nHeight );
			oProgressPlayVideo.graphics.endFill();
			oProgressPlayVideo.visible = false;// masquée par défaut
			addChild( oProgressPlayVideo );	
		}
		
		
 
 		/**
 		 * Appel lorsque la vidéo est en lecture, durée écoulée.
 		 * 
 		 */
		private function onCurrentTimeChangeHandler( e:TimeEvent ):void
		{
			var nPourcent:Number = (e.time / oMediaPlayerSprite.mediaPlayer.duration ); 
			oProgressPlayVideo.scaleX = nPourcent;
			
			oInfosDuration.text = secondsToMinutes( e.time )+" / "+secondsToMinutes( oMediaPlayerSprite.mediaPlayer.duration );
		}
 	
 
 		/**
 		 * Clique de l'utilisateur sur la barre d'avance rapide.
 		 * 
 		 */
		private function onTrackClickPlay( e:MouseEvent ):void
		{
			MonsterDebugger.trace(this,  "onTrackClickPlay" );
			oMediaPlayerSprite.mediaPlayer.seek( (oTrackVideo.mouseX / oTrackVideo.width) * oMediaPlayerSprite.mediaPlayer.duration );
		}
 
		/**
		 * Taille totale de la vidé en octets.
		 * 
		 */
		private function onBytesTotalChange(event:LoadEvent):void
		{
			MonsterDebugger.trace(this,  "onBytesTotalChange: ");
			nTotalBytesKo = event.bytes;
		}
			
			
		/**
		 * Taille chargée de la vidéo en octets.
		 * 
		 */
		private function onBytesLoadedChange(event:LoadEvent):void
		{
			// MonsterDebugger.trace(this,  "onBytesLoadedChange");
			
			var nBytesLoadedKo:uint = event.bytes;
			var nPourentage:uint = nBytesLoadedKo * 100 / nTotalBytesKo;// calcul le pourcentage de progression du chargement
			
			oInfosEvents.text = "Chargement en cours : "+nPourentage+"%";// mets à jour le texte de progression du chargement
			
			oPisteVideo.scaleX = nPourentage/100;// mets à jour la taille de la barre d'avance rapide par clique de l'utilisateur
			
			// masque le texte à la fin du chargement.
			if( nPourentage >= 100 )	oInfosEvents.visible = false;
			else oInfosEvents.visible = true;
			
			// affiche et positionne les barres "avance rapide"
			if( oMediaPlayerSprite.mediaPlayer.mediaHeight > 0 && !oProgressPlayVideo.visible)
			{
				oProgressPlayVideo.y = oMediaPlayerSprite.mediaPlayer.mediaHeight;
				oProgressPlayVideo.visible = true;
				
				oPisteVideo.y = oMediaPlayerSprite.mediaPlayer.mediaHeight;
				oPisteVideo.visible = true;
				
				oTrackVideo.y = oMediaPlayerSprite.mediaPlayer.mediaHeight;
				oTrackVideo.visible = true;
				
				oMediaPlayerSprite.mediaPlayer.pause();// désactive la lecture automatique
			}

		}
			
			
		/**
		 * Appel à chaque appui sur le bouton Play / Pause de la vidéo (ou sur la vidéo)
		 * 
		 */
		private function onPlayPauseClick(event : MouseEvent) : void
		{
			//MonsterDebugger.trace(this,  "onPlayPauseClick");
			// si la player est en lecture --> mise en pause
			if( oMediaPlayerSprite.mediaPlayer.playing )
				oMediaPlayerSprite.mediaPlayer.pause();
			else
				oMediaPlayerSprite.mediaPlayer.play();
		}

		
		/**
		 * Met le son au maximum ou en silence.
		 * 
		 */
		private function onToggleMuteClick(event:MouseEvent):void
		{
			oMediaPlayerSprite.mediaPlayer.muted = !oMediaPlayerSprite.mediaPlayer.muted;
		}

		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 15);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x00C5DF);// changement de la couleur
			
			return oTxtField;	 
		}		


		/**
		 * Conversion des secondes en minutes - 153 secondes en 02:33
		 * 
		 * @param nValue : nombre de secondes
		 * @return : une chaine de caractère au format 00:00
		 */
		private function secondsToMinutes( nSeconds:uint) : String
		{
			var sTime:String;

			// si la durée est supérieure à 1h00
			if ( nSeconds >= 60 * 60 )
			{
				// Format-> H:MM:SS
				sTime = (Math.floor(nSeconds / (60 * 60))) + // Heures 
				":" + ("0" + Math.floor((nSeconds % (60 * 60)) / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			else
			{
				// Format-> MM:SS
				sTime = ("0" + Math.floor(nSeconds / 60)).substr(-2) + // Minutes 
				":" + ("0" + (nSeconds % 60)).substr(-2);// Secondes
			}
			return sTime;
		}

	}
}
